<template>
  <div>
    <div class="label">Withdraw</div>

    <div class="text-center">
      <div v-if="!errorMessage && !withdrawPayed">
        <div v-if="walletLoaded">
          <h5 class="mb-0">
            You can withdraw
            <span class="h4 fw-bold text-success">{{
              wallet?.availableToWithdraw / 1000
            }}</span>
            sats
          </h5>
          <p class="text-muted fs-7">(no more 😎)</p>
        </div>

        <div class="text-center" v-if="!this.withdrawReqLoaded">
          <IconLoader id="loader" />
          <h4>Loading...</h4>
        </div>
        <div v-else>
          <QrCode id="qrCode" :value="withdrawReq" :width="390" />
        </div>
      </div>

      <!-- ERROR -->
      <Alert
        v-if="errorMessage"
        :message="errorMessage"
        :title="errorTitle"
        :type="errorType"
      />

      <!-- Withdraw success - Checkmark -->
      <div v-if="!errorMessage && withdrawPayed">
        <LottieAnimation
          path="img/anim/checkmark.json"
          :width="150"
          :height="150"
          :loop="false"
        />
        <h4>
          You successfully withdrawed
          {{ (withdrawPayment?.amount - withdrawPayment?.fees) / 1000 }} sats
        </h4>
        <p class="text-muted">
          with {{ withdrawPayment?.fees / 1000 }} sats fees
        </p>
      </div>

      <p v-if="wallet?.withdrawAmount && !withdrawPayed" class="text-muted">
        You already withdrawed {{ wallet?.withdrawAmount / 1000 }} sats
      </p>

      <div v-if="!errorMessage && !withdrawPayed">
        <p class="text-muted fs-8">10 sats is reserved for LN fees</p>
        <CopyableText id="payreq-text" :text="withdrawReq" />
      </div>
    </div>
  </div>
</template>

<script>
import Alert from "../components/Alert.vue";
import CopyableText from "../components/CopyableText.vue";
import IconLoader from "../components/IconLoader.vue";
import QrCode from "../components/QrCode.vue";
import LottieAnimation from "lottie-vuejs/src/LottieAnimation.vue";

export default {
  components: { QrCode, IconLoader, Alert, CopyableText, LottieAnimation },
  data() {
    return {
      walletLoaded: false,
      withdrawReqLoaded: false,
      withdrawPayed: false,
      errorMessage: "",
      errorTitle: "",
      errorType: "error",
    };
  },
  computed: {
    withdrawReq() {
      return this.$store.state.wallets.withdrawReq;
    },
    withdrawPayment() {
      return this.$store.state.wallets.withdrawPayment;
    },
    wallet() {
      return this.$store.state.wallets.wallet;
    },
  },
  async created() {
    this.$store.dispatch("clearWithdrawAndWallet").then(() => {
      this.loadWithdraw();
      this.loadWallet();
    });
  },
  methods: {
    loadWithdraw() {
      //Withdraw loading
      if (!this.withdrawReqLoaded) {
        this.$store
          .dispatch("withdraw")
          .then(() => {
            this.withdrawReqLoaded = true;
            this.waitToWithdraw();
          })
          .catch((err) => {
            this.showError(err);
            this.withdrawReqLoaded = true;
          });
      }
    },
    loadWallet() {
      //Wallet loading
      if (!this.walletLoaded) {
        this.$store
          .dispatch("loadWallet")
          .then(() => {
            this.walletLoaded = true;
          })
          .catch((err) => {
            this.showError(err);
            this.walletLoaded = true;
          });
      }
    },
    waitToWithdraw() {
      if (this.withdrawReq) {
        this.$store
          .dispatch("waitToWithdraw")
          .then(() => {
            this.withdrawPayed = true;
            this.withdrawReqLoaded = false;
          })
          .catch((err) => {
            console.log("waitToWithdraw error");
            console.log(err);
          });
      }
    },
    showError(err) {
      this.errorMessage =
        err.viewable && err.message
          ? err.message
          : "Unexpected error occured. Try it again.";
      this.errorTitle = err.title;
      this.errorType = err.type ? err.type : this.errorType;
    },
  },
};
</script>

<style lang="scss" scoped>
#loader {
  width: 100px;
  margin: 5vh auto 0 auto;
}

#qrCode {
  // width: 350px;
  margin: auto;
}

#payreq-text {
  max-width: 500px;
  margin: 0 auto;
}
</style>